#ifndef __IKONKE_MODULE_FACTORY_TEST_H_______________________
#define __IKONKE_MODULE_FACTORY_TEST_H_______________________

#include "ikk-module-def.h"
#include "ikk-debug.h"

// ǷҪ
#define FACTORY_TEST_ENABLE 					true
//ʹdebugٲϻ
#define AGING_DEBUG                 			false
//ť˳ϻ
#define AGING_EXIT_MAX_BTN_NUM					2


//ǿϻʱ粬10A/16AĴ5SϻᴥеֻҪ120S
#define LONG_PRESS_1_TIMES						1
#define LONG_PRESS_2_TIMES						2
//ǿϻʱ
#define TOUCH_KEY_LONG_PRESS_TIME_MS			(5 * 1000)
#define MECHANICAL_KEY_LONG_PRESS_TIME_MS		(20 * 1000)

#define FIRST_BTN_LONG_PRESSED_VALIED_TIME_MS	(15 * 1000)

#define FACTORY_TEST_POLL_TTME_1S				(1 * 1000)
#define FACTORY_TEST_POLL_TTME_10S				(10 * 1000)
#define FACTORY_TEST_POLL_TIMES					(FACTORY_TEST_POLL_TTME_10S / FACTORY_TEST_POLL_TTME_1S)
#if AGING_DEBUG
#define FACTORY_TEST_15MIN_MS					(2 * 60 * 1000)
#define FACTORY_TEST_8HOU_MS					(5 * 1 * 60 * 1000)
#else
#define FACTORY_TEST_15MIN_MS					(15 * 60 * 1000)
#define FACTORY_TEST_8HOU_MS					(8 * 60 * 60 * 1000)
#endif
#define FACTORY_TEST_1S							(1000)

typedef enum{
	FTS_NORMAL=0,
	FTS_START,
	FTS_AGING_15MIN,
	FTS_AGING_8HOU_START,
	FTS_AGING_8HOU,
	FTS_AGING_DONE,
	FTS_AGING_FORCE_EXIT,
	FTS_AGING_WAITING,
	FTS_AGING_FORCE_REBOOT,
	FTS_AGING_FIRST_LONG_PRESSED,
	FTS_AGING_WAITING_SECOND_PRESS
}FactoryTestStatusEnum;

typedef struct{
	uint8_t u8BtnId;
	uint8_t u8BtnLongPressTimes; //touch keys must be long pressed 2 times, mechanical keys is pressed 1 time
	uint32_t u32AgingForceExitTimeMs;  //key long pressed time for  exit aging test
}FactoryTestConfSt;

//10SѯɸݲͬƷԶʵ
typedef void (*pFactoryTestPollCallback)(FactoryTestStatusEnum status);

//ȡǰ״̬
FactoryTestStatusEnum kGetFactoryTestStatus(void);
//void  kGetFactoryTestBtnAction(uint8_t btn_id, BtnActionEnum action);
void kFactoryTestInit(pFactoryTestPollCallback callback, FactoryTestConfSt conf_list[], uint8_t btn_num);

#endif

